#pragma semicolon 1

#include <sourcemod>
#include <custom_rounds>
#include <vip_core>
#include <vip_fm>

#pragma newdecls required

public Plugin myinfo = 
{
	name = "[VIP][FM] Custom Rounds Off",
	author = "R1KO",
	version = "1.2"
};

ArrayList g_hVIPArray;

public void OnPluginStart()
{
	g_hVIPArray = new ArrayList(ByteCountToCells(64));
}

public void OnMapStart()
{
	g_hVIPArray.Clear();

	char szBuffer[256];
	BuildPath(Path_SM, szBuffer, sizeof(szBuffer), "data/vip/modules/cr_off.ini");

	File hFile = OpenFile(szBuffer, "r");

	if(hFile != null)
	{
		int iEndPos;
		while (!hFile.EndOfFile() && hFile.ReadLine(szBuffer, sizeof(szBuffer)))
		{
			if(szBuffer[0])
			{
				iEndPos = StrContains(szBuffer, "//");
				
				if(iEndPos != -1)
				{
					szBuffer[iEndPos] = 0;
				}

				TrimString(szBuffer);

				if(szBuffer[0] && IsCharAlpha(szBuffer[0]))
				{
					g_hVIPArray.PushString(szBuffer);
				}
			}
		}

		delete hFile;
	}
}

public void CR_OnRoundStart(KeyValues Kv)
{
	if (!Kv) {
		return;
	}
	if(Kv.GetNum("vip_disable"))
	{
		for(int i = 1; i <= MaxClients; ++i)
		{
			if(IsClientInGame(i) && VIP_IsClientVIP(i))
			{
				Toggle(i, false);
			}
		}
	}
}

public void CR_OnRoundEnd(KeyValues Kv)
{
	if (!Kv) {
		return;
	}
	if(Kv.GetNum("vip_disable"))
	{
		for(int i = 1; i <= MaxClients; ++i)
		{
			if(IsClientInGame(i) && VIP_IsClientVIP(i))
			{
				Toggle(i, true);
			}
		}
	}
}

void Toggle(int iClient, bool bState)
{
	VIPFM_ToggleFeatures(iClient, bState, g_hVIPArray);

	if(bState)
	{
		VIP_PrintToChatClient(iClient, "\x03Привилегии снова активированы");
	}
	else
	{
		char szName[128];
		CR_GetCurrentRoundName(szName, sizeof(szName));
		VIP_PrintToChatClient(iClient, "\x02У вас были отключены некоторые VIP-привилегии из-за раунда: %s", szName);
		VIP_PrintToChatClient(iClient, "\x03Они включатся в след. раунде автоматически");
	}
}